Index: /branches/dev_001_GM/NEMO/OPA_SRC/TRA/traadv_eiv.F90
===================================================================
--- /branches/dev_001_GM/NEMO/OPA_SRC/TRA/traadv_eiv.F90	(revision 790)
+++ /branches/dev_001_GM/NEMO/OPA_SRC/TRA/traadv_eiv.F90	(revision 791)
@@ -5,4 +5,5 @@
    !!======================================================================
    !! History :  9.0  !  05-11  (G. Madec)  Original code, from traldf and zdf _iso
+   !!            2.4  !  2008-01  (G. Madec)  merge TRC-TRA + switch from velocity to transport
    !!----------------------------------------------------------------------
 #if defined key_traldf_eiv   ||   defined key_esopa
@@ -32,6 +33,6 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !!  OPA 9.0 , LOCEAN-IPSL (2006) 
-   !! $Header$ 
+   !! NEMO/OPA 2.4 , LOCEAN-IPSL (2008) 
+   !! $Id:$ 
    !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
@@ -43,21 +44,22 @@
       !!                  ***  ROUTINE tra_adv_eiv  ***
       !! 
-      !! ** Purpose :   Compute the before horizontal tracer (t & s) diffusive 
-      !!      trend and add it to the general trend of tracer equation.
-      !!
-      !! ** Method  :   The eddy induced advection is computed from the slope
+      !! ** Purpose :   Compute the eddy induced transport and add it to the
+      !!              effective transport
+      !!
+      !! ** Method  :   The eddy induced transport is computed from the slope
       !!      of iso-neutral surfaces computed in routine ldf_slp as follows:
-      !!         zu_eiv =  1/(e2u e3u)   dk[ aeiu e2u mi(wslpi) ]
-      !!         zv_eiv =  1/(e1v e3v)   dk[ aeiv e1v mj(wslpj)
-      !!         zw_eiv = -1/(e1t e2t) { di[ aeiu e2u mi(wslpi) ]
-      !!                               + dj[ aeiv e1v mj(wslpj) ] }
+      !!         zu_eiv =   dk[ aeiu e2u mi(wslpi) ]
+      !!         zv_eiv =   dk[ aeiv e1v mj(wslpj) ]
+      !!         zw_eiv = - { di[ aeiu e2u mi(wslpi) ] + dj[ aeiv e1v mj(wslpj) ] }
       !!      add the eiv component to the model velocity:
       !!         p.n = p.n + z._eiv
+      !! CAUTION : the horizontal transports not updated along jpi column and jpj row
+      !!           the vertical   transports not updated along 1 & jpi columns and 1 & jpj rows
       !!
       !! ** Action  : - add to p.n the eiv component
       !!----------------------------------------------------------------------
       INTEGER , INTENT(in   )                         ::   kt    ! ocean time-step index
-      REAL(wp), INTENT(inout), DIMENSION(jpi,jpj,jpk) ::   pun   ! in : 3 ocean velocity components 
-      REAL(wp), INTENT(inout), DIMENSION(jpi,jpj,jpk) ::   pvn   ! out: 3 ocean velocity components
+      REAL(wp), INTENT(inout), DIMENSION(jpi,jpj,jpk) ::   pun   ! in : 3 ocean transport components 
+      REAL(wp), INTENT(inout), DIMENSION(jpi,jpj,jpk) ::   pvn   ! out: 3 ocean transport components
       REAL(wp), INTENT(inout), DIMENSION(jpi,jpj,jpk) ::   pwn   !      increased by the eiv
       !!
@@ -88,12 +90,12 @@
                zvwk1= ( wslpj(ji,jj,jk+1) + wslpj(ji,jj+1,jk+1) ) * fsaeiv(ji,jj,jk+1) * vmask(ji,jj,jk+1)
 
-               zu_eiv = 0.5 * umask(ji,jj,jk) * ( zuwk - zuwk1 ) / fse3u(ji,jj,jk)
-               zv_eiv = 0.5 * vmask(ji,jj,jk) * ( zvwk - zvwk1 ) / fse3v(ji,jj,jk)
+               zu_eiv = 0.5 * umask(ji,jj,jk) * ( zuwk - zuwk1 )
+               zv_eiv = 0.5 * vmask(ji,jj,jk) * ( zvwk - zvwk1 )
    
-               pun(ji,jj,jk) = pun(ji,jj,jk) + zu_eiv
-               pvn(ji,jj,jk) = pvn(ji,jj,jk) + zv_eiv
-# if defined key_diaeiv
-               u_eiv(ji,jj,jk) = zu_eiv
-               v_eiv(ji,jj,jk) = zv_eiv
+               pun(ji,jj,jk) = pun(ji,jj,jk) + e2u(ji,jj) * zu_eiv
+               pvn(ji,jj,jk) = pvn(ji,jj,jk) + e1v(ji,jj) * zv_eiv
+# if defined key_diaeiv
+               u_eiv(ji,jj,jk) = zu_eiv / fse3u(ji,jj,jk)
+               v_eiv(ji,jj,jk) = zv_eiv / fse3v(ji,jj,jk)
 # endif
             END DO
@@ -115,11 +117,10 @@
                   zvwj1 = ( wslpj(ji,jj,jk) + wslpj(ji,jj+1,jk) ) * e1v(ji  ,jj) * vmask(ji  ,jj,jk)
 
-                  zw_eiv = - 0.5 * tmask(ji,jj,jk) * fsaeiw(ji,jj,jk) * ( zuwi1 - zuwi + zvwj1 - zvwj )  &
-                     &                                                / ( e1t(ji,jj)*e2t(ji,jj) )
+                  zw_eiv = - 0.5 * tmask(ji,jj,jk) * fsaeiw(ji,jj,jk) * ( zuwi1 - zuwi + zvwj1 - zvwj )
 # endif
                   pwn(ji,jj,jk) = pwn(ji,jj,jk) + zw_eiv
 
 # if defined key_diaeiv
-                  w_eiv(ji,jj,jk) = zw_eiv
+                  w_eiv(ji,jj,jk) = zw_eiv / ( e1t(ji,jj)*e2t(ji,jj) )
 # endif
                END DO
@@ -130,4 +131,84 @@
       !                                             ! =================
    END SUBROUTINE tra_adv_eiv
+
+
+!!gm   test tra_adv_eiv better (faster) coded?  to be verified
+
+   SUBROUTINE tra_adv_eiv2( kt, pun, pvn, pwn )
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE tra_adv_eiv  ***
+      !! 
+      !! ** Purpose :   Compute the eddy induced transport and add it to the
+      !!              effective transport
+      !!
+      !! ** Method  :   The eddy induced transport is computed from the slope
+      !!              of iso-neutral surfaces (see ldfslp.F90) as follows:
+      !!                   zu_eiv =   dk[ aeiu e2u mi(wslpi) ]
+      !!                   zv_eiv =   dk[ aeiv e1v mj(wslpj) ]
+      !!                   zw_eiv = - { di[ aeiu e2u mi(wslpi) ] + dj[ aeiv e1v mj(wslpj) ] }
+      !!              add the eiv component to the model velocity:
+      !!                   p.n = p.n + z._eiv
+      !! CAUTION : the horizontal transports not updated along jpi column and jpj row
+      !!           the vertical   transports not updated along 1 & jpi columns and 1 & jpj rows
+      !!
+      !! ** Action  : - add to p.n the eiv transport component
+      !!----------------------------------------------------------------------
+      INTEGER , INTENT(in   )                         ::   kt    ! ocean time-step index
+      REAL(wp), INTENT(inout), DIMENSION(jpi,jpj,jpk) ::   pun   ! in : 3 ocean transport components 
+      REAL(wp), INTENT(inout), DIMENSION(jpi,jpj,jpk) ::   pvn   ! out: 3 ocean transport components
+      REAL(wp), INTENT(inout), DIMENSION(jpi,jpj,jpk) ::   pwn   !      increased by the eiv
+      !!
+      INTEGER  ::   ji, jj, jk                 ! dummy loop indices
+      REAL(wp) ::   zuwslpi, zvwslpj           ! temporary scalar
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zsfu, zsfv   ! eiv stream-function in u and v directions
+      !!----------------------------------------------------------------------
+
+      IF( kt == nit000 ) THEN
+         IF(lwp) WRITE(numout,*)
+         IF(lwp) WRITE(numout,*) 'tra_adv_eiv : eddy induced advection :'
+         IF(lwp) WRITE(numout,*) '~~~~~~~~~~~   add to velocity fields the eiv component'
+      ENDIF
+
+      ! eiv stream-function in u- and v-directions
+      ! NB: UW-point mask at level k is umask(:,:,k) idem form VW-point mask
+      zsfu(:,:, 1 ) = 0.e0   ;   zsfv(:,:, 1 ) = 0.e0      ! surface value set to zero
+      zsfu(:,:,jpk) = 0.e0   ;   zsfv(:,:,jpk) = 0.e0      ! bottom  value set to zero
+      DO jk = 2, jpkm1
+         DO jj = 1, jpjm1
+            DO ji = 1, fs_jpim1   ! vector opt.
+               zuwslpi = 0.5 * ( wslpi(ji+1,jj,jk) + wslpi(ji,jj,jk) )
+               zvwslpj = 0.5 * ( wslpj(ji,jj+1,jk) + wslpj(ji,jj,jk) ) 
+               zsfu(ji,jj,jk) = zuwslpi * e2u(ji,jj) * fsaeiu(ji,jj,jk) * umask(ji,jj,jk)
+               zsfv(ji,jj,jk) = zvwslpj * e1v(ji,jj) * fsaeiv(ji,jj,jk) * vmask(ji,jj,jk)
+            END DO
+         END DO
+      END DO
+# if defined key_diaeiv
+      ! save eiv stream function in the output
+!!gm  to be done, u_sfeiv and v_sfeiv not defined    ==> new IOM....
+!!gm  and zsfu, zfv notdefined for jpi column and jpj row
+!     u_sfeiv(:,:,:) = zsfu(:,:,:)
+!     v_sfeiv(:,:,:) = zsfu(:,:,:)
+# endif
+
+      ! increase the transport with the eiv transport
+      DO jk = 1, jpkm1
+         DO jj = 1, jpjm1
+            DO ji = 1, fs_jpim1   ! vector opt.
+               pun(ji,jj,jk) = pun(ji,jj,jk) + ( zsfu(ji,jj,jk) - zsfu(ji,jj,jk+1) )
+               pvn(ji,jj,jk) = pvn(ji,jj,jk) + ( zsfv(ji,jj,jk) - zsfv(ji,jj,jk+1) )
+            END DO
+         END DO
+      END DO
+      DO jk = 2, jpkm1
+         DO jj = 2, jpjm1
+            DO ji = fs_2, fs_jpim1   ! vector opt.
+               pwn(ji,jj,jk) = pwn(ji,jj,jk) - (  zsfu(ji,jj,jk) - zsfu(ji-1,jj  ,jk)                        &
+                  &                             + zsfv(ji,jj,jk) - zsfv(ji  ,jj-1,jk)  ) * tmask(ji,jj,jk)
+            END DO
+         END DO
+      END DO
+      !
+   END SUBROUTINE tra_adv_eiv2
 
 #else
Index: /branches/dev_001_GM/NEMO/OPA_SRC/TRA/traadv_muscl.F90
===================================================================
--- /branches/dev_001_GM/NEMO/OPA_SRC/TRA/traadv_muscl.F90	(revision 790)
+++ /branches/dev_001_GM/NEMO/OPA_SRC/TRA/traadv_muscl.F90	(revision 791)
@@ -4,8 +4,8 @@
    !! Ocean active tracers:  horizontal & vertical advective trend
    !!======================================================================
-   !! History :       !  06-00  (A.Estublier)  for passive tracers
-   !!                 !  01-08  (E.Durand, G.Madec)  adapted for T & S
-   !!   NEMO     1.0  !  02-06  (G. Madec)  F90: Free form and module
-   !!            2.4  !  08-01  (G. Madec) Merge TRA-TRC
+   !! History :  OPA  !  2006-00  (A.Estublier)  for passive tracers
+   !!            8.2  !  2001-08  (E.Durand, G.Madec)  adapted for T & S
+   !!   NEMO     1.0  !  2002-06  (G. Madec)  F90: Free form and module
+   !!            2.4  !  2008-01  (G. Madec)  merge TRC-TRA + switch from velocity to transport
    !!----------------------------------------------------------------------
 
@@ -28,5 +28,5 @@
    PRIVATE
 
-   PUBLIC   tra_adv_muscl  ! routine called by step.F90
+   PUBLIC   tra_adv_muscl   ! routine called by step.F90
 
    !! * Substitutions
@@ -35,5 +35,5 @@
    !!----------------------------------------------------------------------
    !! NEMO/OPA 2.4 , LOCEAN-IPSL (2008) 
-   !! $Id:$ 
+   !! $Id$ 
    !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
@@ -66,9 +66,8 @@
       !!
       INTEGER  ::   ji, jj, jk   ! dummy loop indices
-      REAL(wp) ::   zu, zv, zw, zeu, zev  
-      REAL(wp) ::   zew, zbtr, z2, zstep 
-      REAL(wp) ::   z0u, z0v, z0w 
-      REAL(wp) ::   zzwx, zzwy, zalpha 
-      REAL(wp) ::   zta
+      REAL(wp) ::   zu, z0u, zzwx
+      REAL(wp) ::   zv, z0v, zzwy 
+      REAL(wp) ::   zw, z0w 
+      REAL(wp) ::   zbtr, z2, zdt, zalpha 
       REAL(wp), DIMENSION (jpi,jpj,jpk) ::   zwx, zwy, zslpx, zslpy   ! 3D workspace
       !!----------------------------------------------------------------------
@@ -80,13 +79,13 @@
       ENDIF
 
-      IF( neuler == 0 .AND. kt == nit000 ) THEN   ;    z2 = 1.
-      ELSE                                        ;    z2 = 2.
+      IF( neuler == 0 .AND. kt == nit000 ) THEN   ;    z2 = 1.      ! euler     time-stepping
+      ELSE                                        ;    z2 = 2.      ! leap-frog time-stepping
       ENDIF
 
       ! I. Horizontal advective fluxes
       ! ------------------------------
-      ! first guess of the slopes
-      ! interior values
-      DO jk = 1, jpkm1
+      !                                             !-- first guess of the slopes
+      zwx(:,:,jpk) = 0.e0   ;   zwy(:,:,jpk) = 0.e0        ! bottom values
+      DO jk = 1, jpkm1                                     ! interior values
          DO jj = 1, jpjm1      
             DO ji = 1, fs_jpim1   ! vector opt.
@@ -96,116 +95,91 @@
          END DO
       END DO
-      ! bottom values
-      zwx(:,:,jpk) = 0.e0    ;    zwy(:,:,jpk) = 0.e0
-
-      ! lateral boundary conditions on zwx, zwy   (changed sign)
-      CALL lbc_lnk( zwx, 'U', -1. )   ;   CALL lbc_lnk( zwy, 'V', -1. )
-
-      ! Slopes
-      ! interior values
-      DO jk = 1, jpkm1
-         DO jj = 2, jpj
-            DO ji = fs_2, jpi   ! vector opt.
+!!gm optimisation (lbc to be suppressed)
+      CALL lbc_lnk( zwx, 'U', -1. )                        ! lateral boundary conditions on zwx, zwy   (changed sign)
+      CALL lbc_lnk( zwy, 'V', -1. )
+!!gm
+
+      !                                             !-- Slopes of tracer
+      zslpx(:,:,jpk) = 0.e0   ;   zslpy(:,:,jpk) = 0.e0    ! bottom values
+      DO jk = 1, jpkm1                                     ! interior values
+         DO jj = 2, jpjm1
+            DO ji = fs_2, jpim1   ! vector opt.
                zslpx(ji,jj,jk) =                    ( zwx(ji,jj,jk) + zwx(ji-1,jj  ,jk) )   &
-                  &           * ( 0.25 + SIGN( 0.25, zwx(ji,jj,jk) * zwx(ji-1,jj  ,jk) ) )
+                  &            * ( 0.25 + SIGN( 0.25, zwx(ji,jj,jk) * zwx(ji-1,jj  ,jk) ) )
                zslpy(ji,jj,jk) =                    ( zwy(ji,jj,jk) + zwy(ji  ,jj-1,jk) )   &
-                  &           * ( 0.25 + SIGN( 0.25, zwy(ji,jj,jk) * zwy(ji  ,jj-1,jk) ) )
-            END DO
-         END DO
-      END DO
-      ! bottom values
-      zslpx(:,:,jpk) = 0.e0    ;    zslpy(:,:,jpk) = 0.e0
-
-      ! Slopes limitation
-      DO jk = 1, jpkm1
-         DO jj = 2, jpj
-            DO ji = fs_2, jpi   ! vector opt.
-               zslpx(ji,jj,jk) = SIGN( 1., zslpx(ji,jj,jk) )   &
-                  &            * MIN(    ABS( zslpx(ji  ,jj,jk) ),   &
-                  &                   2.*ABS( zwx (ji-1,jj,jk) ),   &
-                  &                   2.*ABS( zwx (ji  ,jj,jk) ) )
-               zslpy(ji,jj,jk) = SIGN( 1., zslpy(ji,jj,jk) )   &
-                  &            * MIN(    ABS( zslpy(ji,jj  ,jk) ),   &
-                  &                   2.*ABS( zwy (ji,jj-1,jk) ),   &
-                  &                   2.*ABS( zwy (ji,jj  ,jk) ) )
+                  &            * ( 0.25 + SIGN( 0.25, zwy(ji,jj,jk) * zwy(ji  ,jj-1,jk) ) )
+            END DO
+         END DO
+      END DO
+!!gm  :merge the 2 loop (above & below)
+      DO jk = 1, jpkm1                                     ! Slopes limitation
+         DO jj = 2, jpjm1
+            DO ji = fs_2, jpim1   ! vector opt.
+               zslpx(ji,jj,jk) = SIGN( 1., zslpx(ji,jj,jk) ) * MIN(    ABS( zslpx(ji  ,jj,jk) ),   &
+                  &                                                 2.*ABS( zwx  (ji-1,jj,jk) ),   &
+                  &                                                 2.*ABS( zwx  (ji  ,jj,jk) ) )
+               zslpy(ji,jj,jk) = SIGN( 1., zslpy(ji,jj,jk) ) * MIN(    ABS( zslpy(ji,jj  ,jk) ),   &
+                  &                                                 2.*ABS( zwy  (ji,jj-1,jk) ),   &
+                  &                                                 2.*ABS( zwy  (ji,jj  ,jk) ) )
             END DO
          END DO
       END DO        
-
-      ! Advection terms
-      ! interior values
-      DO jk = 1, jpkm1
-         zstep  = z2 * rdttra(jk)
-         DO jj = 2, jpjm1      
-            DO ji = fs_2, fs_jpim1   ! vector opt.
-               ! volume fluxes
-#if defined key_zco
-               zeu = e2u(ji,jj)                   * pun(ji,jj,jk)
-               zev = e1v(ji,jj)                   * pvn(ji,jj,jk)
-#else
-               zeu = e2u(ji,jj) * fse3u(ji,jj,jk) * pun(ji,jj,jk)
-               zev = e1v(ji,jj) * fse3v(ji,jj,jk) * pvn(ji,jj,jk)
-#endif
-               ! MUSCL fluxes
+!!gm optimisation:  call lbclnk just 1 time here on zslpx & zslpy
+!!    CALL lbc_lnk( zslpx, 'U', -1. )                      ! lateral boundary conditions on zwx, zwy   (changed sign)
+!!    CALL lbc_lnk( zslpy, 'V', -1. )
+!!
+!! and loop below from 1 to jpjm1 and to jpim1
+!!gm
+
+      !                                             !-- MUSCL horizontal advective fluxes
+      DO jk = 1, jpkm1                                     ! interior values
+         zdt  = z2 * rdttra(jk)
+         DO jj = 2, jpjm1      
+            DO ji = fs_2, fs_jpim1   ! vector opt.
                z0u = SIGN( 0.5, pun(ji,jj,jk) )            
                zalpha = 0.5 - z0u
-               zu  = z0u - 0.5 * pun(ji,jj,jk) * zstep / e1u(ji,jj)
+               zu  = z0u - 0.5 * pun(ji,jj,jk) * zdt / ( e1u(ji,jj) * e2u(ji,jj) * fse3u(ji,jj,jk) )
                zzwx = ptb(ji+1,jj,jk) + zu * zslpx(ji+1,jj,jk)
                zzwy = ptb(ji  ,jj,jk) + zu * zslpx(ji  ,jj,jk)
-               zwx(ji,jj,jk) = zeu * ( zalpha * zzwx + (1.-zalpha) * zzwy )
+               zwx(ji,jj,jk) = pun(ji,jj,jk) * ( zalpha * zzwx + (1.-zalpha) * zzwy )
                !
                z0v = SIGN( 0.5, pvn(ji,jj,jk) )            
                zalpha = 0.5 - z0v
-               zv  = z0v - 0.5 * pvn(ji,jj,jk) * zstep / e2v(ji,jj)
+               zv  = z0v - 0.5 * pvn(ji,jj,jk) * zdt / ( e1v(ji,jj) * e2v(ji,jj) * fse3v(ji,jj,jk) )
                zzwx = ptb(ji,jj+1,jk) + zv * zslpy(ji,jj+1,jk)
                zzwy = ptb(ji,jj  ,jk) + zv * zslpy(ji,jj  ,jk)
-               zwy(ji,jj,jk) = zev * ( zalpha * zzwx + (1.-zalpha) * zzwy )
-            END DO
-         END DO
-      END DO
-
-!!gm bug?   there is too many lbc: this have to be checked
-      ! lateral boundary conditions on zwx, zwy   (changed sign)
+               zwy(ji,jj,jk) = pvn(ji,jj,jk) * ( zalpha * zzwx + (1.-zalpha) * zzwy )
+            END DO
+         END DO
+      END DO
+!!gm optimisation (lbc to be suppressed)
+      !                                                    ! lateral boundary conditions on zwx, zwy   (changed sign)
       CALL lbc_lnk( zwx, 'U', -1. )   ;   CALL lbc_lnk( zwy, 'V', -1. )
-
+!!gm
+
+      !                                             !-- MUSCL advective trend
       ! Tracer flux divergence at t-point added to the general trend
       DO jk = 1, jpkm1
          DO jj = 2, jpjm1      
             DO ji = fs_2, fs_jpim1   ! vector opt.
-#if defined key_zco
-               zbtr = 1. / ( e1t(ji,jj) * e2t(ji,jj) )
-#else
                zbtr = 1. / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
-#endif
-               ! horizontal advective trends
-               zta = - zbtr * ( zwx(ji,jj,jk) - zwx(ji-1,jj  ,jk  )   &
-                  &           + zwy(ji,jj,jk) - zwy(ji  ,jj-1,jk  ) ) 
-               ! add it to the general tracer trends
-               pta(ji,jj,jk) = pta(ji,jj,jk) + zta
+               ! horizontal advective trends added to the general tracer trends
+               pta(ji,jj,jk) = pta(ji,jj,jk) - zbtr * ( zwx(ji,jj,jk) - zwx(ji-1,jj  ,jk  )   &
+                  &                                   + zwy(ji,jj,jk) - zwy(ji  ,jj-1,jk  ) ) 
             END DO
         END DO
       END DO        
 
-      IF(ln_ctl)   CALL prt_ctl( tab3d_1=pta, clinfo1=' muscl - had: ', mask1=tmask, clinfo3=cdtype )
-
-      ! Save the horizontal advective trends for diagnostics
-      IF( l_trdtra ) THEN
+      IF( l_trdtra ) THEN                           !-- trend diagnostics
          CALL trd_tra_adv( kt, ktra, jpt_trd_xad, cdtype, zwx, pun, ptb )
          CALL trd_tra_adv( kt, ktra, jpt_trd_yad, cdtype, zwy, pvn, ptb )
       ENDIF
-
+      !                                             !-- "Poleward" heat or salt transports
       IF( cdtype == 'TRA' .AND. ln_diaptr .AND. ( MOD( kt, nf_ptr ) == 0 ) ) THEN
-         IF( lk_zco ) THEN
-            DO jk = 1, jpkm1
-               DO jj = 2, jpjm1
-                  DO ji = fs_2, fs_jpim1   ! vector opt.
-                    zwy(ji,jj,jk) = zwy(ji,jj,jk) * fse3v(ji,jj,jk)
-                  END DO
-               END DO
-            END DO
-         ENDIF
          IF( ktra == jp_tem)   pht_adv(:) = ptr_vj( zwy(:,:,:) )
          IF( ktra == jp_sal)   pst_adv(:) = ptr_vj( zwy(:,:,:) )
       ENDIF
+      !                                             !-- control print
+      IF(ln_ctl)   CALL prt_ctl( tab3d_1=pta, clinfo1=' muscl - had: ', mask1=tmask, clinfo3=cdtype )
 
 
@@ -213,14 +187,13 @@
       ! -----------------------------
       
-      ! First guess of the slope
-      ! interior values
-      DO jk = 2, jpkm1
+      !                                             !-- first guess of the slopes
+      zwx (:,:, 1 ) = 0.e0    ;    zwx (:,:,jpk) = 0.e0    ! surface & bottom boundary conditions
+      DO jk = 2, jpkm1                                     ! interior values
          zwx(:,:,jk) = tmask(:,:,jk) * ( ptb(:,:,jk-1) - ptb(:,:,jk) )
       END DO
-      ! surface & bottom boundary conditions
-      zwx (:,:, 1 ) = 0.e0    ;    zwx (:,:,jpk) = 0.e0
-
-      ! Slopes
-      DO jk = 2, jpkm1
+
+      !                                             !-- Slopes of tracer
+      zslpx(:,:,1) = 0.e0                                  ! surface values
+      DO jk = 2, jpkm1                                     ! interior value
          DO jj = 1, jpj
             DO ji = 1, jpi
@@ -230,60 +203,49 @@
          END DO
       END DO
-
-      ! Slopes limitation
-      DO jk = 2, jpkm1        ! interior values
+!!gm : merge the above and below loops
+      !                                             !-- Slopes limitation
+      DO jk = 2, jpkm1                                     ! interior values
          DO jj = 1, jpj
             DO ji = 1, jpi
-               zslpx(ji,jj,jk) = SIGN( 1., zslpx(ji,jj,jk) )   &
-                  &            * MIN(    ABS( zslpx(ji,jj,jk  ) ),   &
-                  &                   2.*ABS( zwx (ji,jj,jk+1) ),   &
-                  &                   2.*ABS( zwx (ji,jj,jk  ) ) )
-            END DO
-         END DO
-      END DO
-      zslpx(:,:,1) = 0.e0      ! surface values
-
-      ! vertical advective flux
-      DO jk = 1, jpkm1        ! interior values
-         zstep  = z2 * rdttra(jk)
-         DO jj = 2, jpjm1      
-            DO ji = fs_2, fs_jpim1   ! vector opt.
-               zew = pwn(ji,jj,jk+1)
+               zslpx(ji,jj,jk) = SIGN( 1., zslpx(ji,jj,jk) ) * MIN(    ABS( zslpx(ji,jj,jk  ) ),   &
+                  &                                                 2.*ABS( zwx  (ji,jj,jk+1) ),   &
+                  &                                                 2.*ABS( zwx  (ji,jj,jk  ) )  )
+            END DO
+         END DO
+      END DO
+
+      !                                             !-- vertical advective flux
+      !                                                    ! surface values  (bottom already set to zero)
+      IF( lk_dynspg_rl .OR. lk_vvl) THEN    ;   zwx(:,:, 1 ) = 0.e0                      ! rigid lid or variable volume
+      ELSE                                  ;   zwx(:,:, 1 ) = pwn(:,:,1) * ptb(:,:,1)   ! linear free surface
+      ENDIF
+      DO jk = 1, jpkm1                                     ! interior values
+         zdt  = z2 * rdttra(jk)
+         DO jj = 2, jpjm1      
+            DO ji = fs_2, fs_jpim1   ! vector opt.
                z0w = SIGN( 0.5, pwn(ji,jj,jk+1) )
                zalpha = 0.5 + z0w
-               zw  = z0w - 0.5 * pwn(ji,jj,jk+1) * zstep / fse3w(ji,jj,jk+1)
+               zw  = z0w - 0.5 * pwn(ji,jj,jk+1) * zdt / (e1t(ji,jj) * e2t(ji,jj) * fse3w(ji,jj,jk+1) )
                zzwx = ptb(ji,jj,jk+1) + zw * zslpx(ji,jj,jk+1)
                zzwy = ptb(ji,jj,jk  ) + zw * zslpx(ji,jj,jk  )
-               zwx(ji,jj,jk+1) = zew * ( zalpha * zzwx + (1.-zalpha) * zzwy )
-            END DO
-         END DO
-      END DO
-      !                       ! surface values
-      IF( lk_dynspg_rl .OR. lk_vvl) THEN                ! rigid lid or variable volume: flux set to zero
-         zwx(:,:, 1 ) = 0.e0                                 ! surface 
-         zwx(:,:,jpk) = 0.e0                                 ! bottom 
-      ELSE                                              ! free surface
-         zwx(:,:, 1 ) = pwn(:,:,1) * ptb(:,:,1)              ! Surface
-         zwx(:,:,jpk) = 0.e0                                 ! bottom 
-
-      ENDIF
-
-      ! Compute & add the vertical advective trend
+               zwx(ji,jj,jk+1) = pwn(ji,jj,jk+1) * ( zalpha * zzwx + (1.-zalpha) * zzwy )
+            END DO
+         END DO
+      END DO
+
+      !                                             !-- vertical advective trend
       DO jk = 1, jpkm1
          DO jj = 2, jpjm1      
             DO ji = fs_2, fs_jpim1   ! vector opt.
-               zbtr = 1. / fse3t(ji,jj,jk)
-               ! horizontal advective trends
-               zta = - zbtr * ( zwx(ji,jj,jk) - zwx(ji,jj,jk+1) )
-               ! add it to the general tracer trends
-               pta(ji,jj,jk) =  pta(ji,jj,jk) + zta
-            END DO
-         END DO
-      END DO
-
-      ! Save the vertical advective trends for diagnostic
-      ! -------------------------------------------------
+               zbtr = 1. / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
+               ! horizontal advective trends added to the general tracer trends
+               pta(ji,jj,jk) =  pta(ji,jj,jk) - zbtr * ( zwx(ji,jj,jk) - zwx(ji,jj,jk+1) )
+            END DO
+         END DO
+      END DO
+
+      !                                             !-- trend diagnostic
       IF( l_trdtra )   CALL trd_tra_adv( kt, ktra, jpt_trd_zad, cdtype, zwx, pwn, ptb )
-
+      !                                             !-- control print
       IF(ln_ctl)   CALL prt_ctl( tab3d_1=pta, clinfo1=' muscl - zad: ', mask1=tmask, clinfo3=cdtype )
       !
